//
// Hanghullmok
//
#ifndef _HANGOK_
#define _HANGOK_
//
#include <dsound.h>
extern HWND hwnd;

class WAV
{
public:
	WAV();
	~WAV();
	bool initwave();					
	DWORD loadwave(LPCTSTR nev);				//visszatr a wave hosszval
	DWORD readwave(LPVOID buff);				// a wave hosszval lefoglalt puffermutatra msol
	void playsound(int a=0,int a1=0,int b=0);	// a s a1 lejtsza az a-val mutatott hangot,
	int get_darab(){return ds_darab;};			//ha pp lejtszott akkor vlaszt az a1 ig msikat ha b=0
												//b <> 0 akkor folyamatos lejtszs
	void stopsound	(int);
	void setvolume	(int,int);			
	void restore	(int);
protected:
	LPDIRECTSOUND		dsound;					//dsound obj mutat
	LPDIRECTSOUNDBUFFER dsbuff[32];				//dsoundbuffer
	WAVEFORMATEX		w_format;				//hullmformtum informci
	HMMIO				hmmio;					//handle  a wave fjl-ra
	DWORD				w_hossz;				//betlttt wave adat hossza
	PBYTE				w_data;					//ideiglenesen betlttt Wave adatok mutatja
	int					ds_darab;				//ltrehozott hangpufferek szma;
	void				torol_buff();

};
//
//MEGVALSTSOK
//
WAV::WAV()
{
	dsound=NULL;	ds_darab=0;	hmmio=NULL;	w_data=NULL;
	for(int i=0;i<32;i++){dsbuff[i]=NULL;}
	
}
WAV::~WAV()
{
	torol_buff();
}
//
void WAV::torol_buff()
{
	for( int i=0;i<32;i++)	//32 puffer felszabadtsa
	{if(dsbuff[i])
		{
			dsbuff[i]->Release();dsbuff[i]=NULL;
		}
	}
	if(dsound)
	{
		dsound->Release(),dsound=NULL;//Hang objektum megszntetse
	}
	ds_darab=0;
}
//

//
DWORD WAV::loadwave(LPCTSTR nev)
{
	w_hossz=0;
	MMCKINFO mmWave;
	MMCKINFO mmFmt;
	MMCKINFO mmData;
	MMRESULT mResult;
	ZeroMemory(&w_format,sizeof(WAVEFORMATEX));
	ZeroMemory(&mmWave,  sizeof(mmWave));
	ZeroMemory(&mmFmt,   sizeof(mmFmt));
	hmmio=mmioOpen((char*)(nev),NULL,MMIO_READ);
	if(!hmmio)
	{
		;goto hiba;//nincs ilyen fjl
	}
	//megszerezzk a formtum struktrjt
	mResult=mmioSeek(hmmio,0,SEEK_SET);
	mmWave.fccType=mmioStringToFOURCC("WAVE",0);
	mmFmt.ckid=mmioDescend(hmmio,&mmWave,NULL,MMIO_FINDRIFF);
	if(mResult != MMSYSERR_NOERROR)
	{
		;goto hiba;
	}
	mResult=mmioDescend(hmmio,&mmFmt,&mmWave,MMIO_FINDCHUNK);
	if(mResult != MMSYSERR_NOERROR)
	{
		goto hiba;//rossz wave formtum
	}
	mResult=mmioRead(hmmio,(HPSTR)&w_format,sizeof(WAVEFORMATEX));
	if(mResult==-1)
	{
		;goto hiba;//nem olvashat forma
	}
	//Megszerezzk a wave adatok hosszt
	mResult=mmioSeek(hmmio,0,SEEK_SET);
	mmData.ckid=mmioStringToFOURCC("data",0);
	mResult=mmioDescend(hmmio,&mmWave,NULL,MMIO_FINDRIFF);
	if(mResult !=MMSYSERR_NOERROR)
	{
		goto hiba;
	}
	mResult=mmioDescend(hmmio,&mmData,&mmWave,MMIO_FINDCHUNK);
	if(mResult !=MMSYSERR_NOERROR)
	{
		goto hiba;//nem lehet megtallni a wave hosszt
	}
	w_hossz=mmData.cksize;
	//Beolvassuk a wave adatot memriba
	if(w_data)
	{
		delete w_data;w_data=NULL;
	}
	w_data=new BYTE [w_hossz];
	if(!w_data)
	{
		goto hiba;//memriahiba
	}
	ZeroMemory(w_data,w_hossz);
	mResult=mmioRead(hmmio,(HPSTR)w_data,w_hossz);
	if(mResult==-1)
	{
		goto hiba;//olvasshiba
	}
	mmioClose(hmmio,0);hmmio=NULL;
	return w_hossz;//megvan a hossz s beolvastuk a memriba
hiba:
	if(hmmio)
	{
		mmioClose(hmmio,0);hmmio=NULL;//lezrjuk a fjlt.
	}
return 0;
}
//
//
DWORD WAV::readwave(LPVOID buff)
{
	CopyMemory(buff,w_data,w_hossz);
		return w_hossz;
}
//
static  char index[]={0,1,1,1,1,1,0,3,2,-1};
static LPCTSTR nevek[]={"snd\\w1.wav","snd\\w2.wav","snd\\w3.wav","snd\\w4.wav","snd\\w5.wav"};
//
bool WAV::initwave()
{
	BYTE* flag1;//betlttt hang mutatja
	static int db=0;int i=0;

	if(dsound)
	{
		torol_buff();	//ha volt, trl minden hang objektumot
	}
	HRESULT inf;
	inf=DirectSoundCreate(NULL, &dsound, NULL);//hangobjektum ltrehozsa
	if(inf !=S_OK)return false;//dsound nem ok
	inf=dsound->SetCooperativeLevel(hwnd,DSSCL_PRIORITY );
	if(inf !=DS_OK)return false;
	while(index[db] !=-1)//megllaptjuk mennyi a betltend hangok szma
	{db++;}
	for(i=0;i<db;i++)	//s annyi msodlagos hangpuffert hozunk ltre
	{
	//	loadwave(nevek[index[i]]);
		DSBUFFERDESC ddesc;
		ZeroMemory(&ddesc,	sizeof(DSBUFFERDESC));
		ddesc.dwSize=		sizeof(DSBUFFERDESC);
		ddesc.dwFlags=		DSBCAPS_CTRLDEFAULT;
		ddesc.dwBufferBytes=loadwave(nevek[index[i]]);
		ddesc.lpwfxFormat=	&w_format;
		inf=dsound->CreateSoundBuffer(&ddesc,&dsbuff[i],NULL);
		if(inf != DS_OK)return false;//hangpuffer nem ok
		if(dsbuff[i]->Lock(0,ddesc.dwBufferBytes,(LPVOID*)&flag1,&w_hossz,NULL,0,0)!=DS_OK)
		return false;		//nem lehet zrolni a h puffert
		readwave(flag1);	//msolunk
		if(dsbuff[i]->Unlock(flag1,w_hossz,NULL,0) !=DS_OK)
		{
			return false;//nem lehet felszabadtani a hangpuffert
		}
		ds_darab++;// az eddig betlttt hangok szma
	}
	return true;
}
void WAV::playsound(int a,int a1,int b)
{
		int sv=a;
pl1:	if(!dsbuff[sv])return;
		if(sv>ds_darab)return;
		DWORD status=0;
		dsbuff[sv]->GetStatus(&status);
		if(status & DSBSTATUS_BUFFERLOST) restore(sv);
		status=0;
		dsbuff[sv]->GetStatus(&status);
		if((status & DSBSTATUS_PLAYING) ==DSBSTATUS_PLAYING)	//ha pp jtszott
		{														//akkor veszi a kvetkezt
			if(!a1)return;										//ha mind pp lejtszott akkor
			sv++;												//az eredetit ellrl kezdi
			if(sv<=(a+a1))goto pl1;								//ha a1 nem NULLA !!
			sv=a;
			dsbuff[sv]->SetCurrentPosition(0);
			return;
		}
		dsbuff[sv]->Play(0,0,b);
}


void WAV::restore(int a)
{

	HRESULT inf;
	BYTE* flag1;
	inf=dsbuff[a]->Restore();
	if(inf !=DS_OK)return;//Ha nem sikerlne visszalltani a hangpuffert akkor nincs mit tenni
	if(dsbuff[a]->Lock(0,loadwave(nevek[index[a]]),(LPVOID*)&flag1,&w_hossz,NULL,0,0)!=DS_OK)//ddesc.dwBufferBytes
	{
		MessageBox(hwnd,"soundbuffer lock hiba","",0);return ;
	}
	readwave(flag1);
	if(dsbuff[a]->Unlock(flag1,w_hossz,NULL,0) !=DS_OK)return;
}

void WAV::setvolume(int a,int b)		//a= melyik puffer b= hanger (0 - -10000)
{
	if(a>ds_darab)return;
	dsbuff[a]->SetVolume(b);
}

void WAV::stopsound(int a)
{
	if(a>ds_darab)return;
	dsbuff[a]->Stop();
	dsbuff[a]->SetCurrentPosition(0);	//  ez visszalltja az elejre ha kell s kvetkeznl
}										//elrl kezdi			


#endif